<?php

declare(strict_types=1);

namespace App\Repository;

final class TblAspiranteFavoritoUsuarioRepository
{
    private \PDO $database;

    public function __construct(\PDO $database)
    {
        $this->database = $database;
    }

    public function getDb(): \PDO
    {
        return $this->database;
    }

    public function checkAndGet(int $TblAspiranteFavoritoUsuarioId): object
    {
        $query = 'SELECT * FROM `TblAspiranteFavoritoUsuario` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblAspiranteFavoritoUsuarioId);
        $statement->execute();
        $TblAspiranteFavoritoUsuario = $statement->fetchObject();
        if (! $TblAspiranteFavoritoUsuario) {
            throw new \Exception('TblAspiranteFavoritoUsuario not found.', 404);
        }

        return $TblAspiranteFavoritoUsuario;
    }

    public function getAll(): array
    {
        $query = 'SELECT * FROM `TblAspiranteFavoritoUsuario` ORDER BY `id`';
        $statement = $this->getDb()->prepare($query);
        $statement->execute();

        return (array) $statement->fetchAll();
    }

    public function create(object $TblAspiranteFavoritoUsuario): object
    {
        $query = 'INSERT INTO `TblAspiranteFavoritoUsuario` (`IdUsuario`, `IdPerfilUsuarioComunidadHigen`, `field1`, `field2`, `field3`, `field4`, `field5`) VALUES (:IdUsuario, :IdPerfilUsuarioComunidadHigen, :field1, :field2, :field3, :field4, :field5)';
        $statement = $this->getDb()->prepare($query);
//         $statement->bindParam('id', $TblAspiranteFavoritoUsuario->id);
//         $statement->bindParam('fecha', $TblAspiranteFavoritoUsuario->fecha);
        $statement->bindParam('IdUsuario', $TblAspiranteFavoritoUsuario->IdUsuario);
        $statement->bindParam('IdPerfilUsuarioComunidadHigen', $TblAspiranteFavoritoUsuario->IdPerfilUsuarioComunidadHigen);
        $statement->bindParam('field1', $TblAspiranteFavoritoUsuario->field1);
        $statement->bindParam('field2', $TblAspiranteFavoritoUsuario->field2);
        $statement->bindParam('field3', $TblAspiranteFavoritoUsuario->field3);
        $statement->bindParam('field4', $TblAspiranteFavoritoUsuario->field4);
        $statement->bindParam('field5', $TblAspiranteFavoritoUsuario->field5);

        $statement->execute();

        return $this->checkAndGet((int) $this->getDb()->lastInsertId());
    }

    public function update(object $TblAspiranteFavoritoUsuario, object $data): object
    {
        if (isset($data->fecha)) {
            $TblAspiranteFavoritoUsuario->fecha = $data->fecha;
        }
        if (isset($data->IdUsuario)) {
            $TblAspiranteFavoritoUsuario->IdUsuario = $data->IdUsuario;
        }
        if (isset($data->IdPerfilUsuarioComunidadHigen)) {
            $TblAspiranteFavoritoUsuario->IdPerfilUsuarioComunidadHigen = $data->IdPerfilUsuarioComunidadHigen;
        }
        if (isset($data->field1)) {
            $TblAspiranteFavoritoUsuario->field1 = $data->field1;
        }
        if (isset($data->field2)) {
            $TblAspiranteFavoritoUsuario->field2 = $data->field2;
        }
        if (isset($data->field3)) {
            $TblAspiranteFavoritoUsuario->field3 = $data->field3;
        }
        if (isset($data->field4)) {
            $TblAspiranteFavoritoUsuario->field4 = $data->field4;
        }
        if (isset($data->field5)) {
            $TblAspiranteFavoritoUsuario->field5 = $data->field5;
        }

        $query = 'UPDATE `TblAspiranteFavoritoUsuario` SET `fecha` = :fecha, `IdUsuario` = :IdUsuario, `IdPerfilUsuarioComunidadHigen` = :IdPerfilUsuarioComunidadHigen, `field1` = :field1, `field2` = :field2, `field3` = :field3, `field4` = :field4, `field5` = :field5 WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblAspiranteFavoritoUsuario->id);
        $statement->bindParam('fecha', $TblAspiranteFavoritoUsuario->fecha);
        $statement->bindParam('IdUsuario', $TblAspiranteFavoritoUsuario->IdUsuario);
        $statement->bindParam('IdPerfilUsuarioComunidadHigen', $TblAspiranteFavoritoUsuario->IdPerfilUsuarioComunidadHigen);
        $statement->bindParam('field1', $TblAspiranteFavoritoUsuario->field1);
        $statement->bindParam('field2', $TblAspiranteFavoritoUsuario->field2);
        $statement->bindParam('field3', $TblAspiranteFavoritoUsuario->field3);
        $statement->bindParam('field4', $TblAspiranteFavoritoUsuario->field4);
        $statement->bindParam('field5', $TblAspiranteFavoritoUsuario->field5);

        $statement->execute();

        return $this->checkAndGet((int) $TblAspiranteFavoritoUsuario->id);
    }

    public function delete(int $TblAspiranteFavoritoUsuarioId): void
    {
        $query = 'DELETE FROM `TblAspiranteFavoritoUsuario` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblAspiranteFavoritoUsuarioId);
        $statement->execute();
    }
}
